searchNodes=[{"doc":"cowboy-swagger main interface.","ref":"cowboy_swagger.html","title":"cowboy_swagger","type":"module"},{"doc":"","ref":"cowboy_swagger.html#add_definition/1","title":"cowboy_swagger.add_definition/1","type":"function"},{"doc":"","ref":"cowboy_swagger.html#add_definition/2","title":"cowboy_swagger.add_definition/2","type":"function"},{"doc":"","ref":"cowboy_swagger.html#add_definition_array/2","title":"cowboy_swagger.add_definition_array/2","type":"function"},{"doc":"","ref":"cowboy_swagger.html#get_existing_definitions/2","title":"cowboy_swagger.get_existing_definitions/2","type":"function"},{"doc":"","ref":"cowboy_swagger.html#get_global_spec/0","title":"cowboy_swagger.get_global_spec/0","type":"function"},{"doc":"","ref":"cowboy_swagger.html#get_global_spec/1","title":"cowboy_swagger.get_global_spec/1","type":"function"},{"doc":"","ref":"cowboy_swagger.html#schema/1","title":"cowboy_swagger.schema/1","type":"function"},{"doc":"","ref":"cowboy_swagger.html#set_global_spec/1","title":"cowboy_swagger.set_global_spec/1","type":"function"},{"doc":"Returns the swagger json specification from given trails . This function basically takes the metadata from each trails:trail() (which must be compliant with Swagger specification) and builds the required swagger.json .","ref":"cowboy_swagger.html#to_json/1","title":"cowboy_swagger.to_json/1","type":"function"},{"doc":"","ref":"cowboy_swagger.html#t:metadata/0","title":"cowboy_swagger.metadata/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:parameter_definition_name/0","title":"cowboy_swagger.parameter_definition_name/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:parameter_obj/0","title":"cowboy_swagger.parameter_obj/0","type":"opaque"},{"doc":"","ref":"cowboy_swagger.html#t:parameters_definition_array/0","title":"cowboy_swagger.parameters_definition_array/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:parameters_definitions/0","title":"cowboy_swagger.parameters_definitions/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:property_desc/0","title":"cowboy_swagger.property_desc/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:property_obj/0","title":"cowboy_swagger.property_obj/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:response_obj/0","title":"cowboy_swagger.response_obj/0","type":"opaque"},{"doc":"","ref":"cowboy_swagger.html#t:responses_definitions/0","title":"cowboy_swagger.responses_definitions/0","type":"type"},{"doc":"","ref":"cowboy_swagger.html#t:swagger_map/0","title":"cowboy_swagger.swagger_map/0","type":"opaque"},{"doc":"","ref":"cowboy_swagger.html#t:swagger_version/0","title":"cowboy_swagger.swagger_version/0","type":"type"},{"doc":"Cowboy Swagger Handler. This handler exposes a GET operation to enable swagger.json to be retrieved from embedded Swagger-UI (located in priv/swagger folder).","ref":"cowboy_swagger_handler.html","title":"cowboy_swagger_handler","type":"module"},{"doc":"","ref":"cowboy_swagger_handler.html#trails/1","title":"cowboy_swagger_handler.trails/1","type":"function"},{"doc":"","ref":"cowboy_swagger_handler.html#t:route_match/0","title":"cowboy_swagger_handler.route_match/0","type":"type"},{"doc":"cowboy-swagger Swagger integration for Cowboy (built on trails ).","ref":"readme.html","title":"README","type":"extras"},{"doc":"If you find any bugs or have a problem while using this library, please open an issue in this repo (or a pull request :)).","ref":"readme.html#contact-us","title":"README - Contact Us","type":"extras"},{"doc":"Simple, because there isn't a tool in Erlang to document Cowboy RESTful APIs easy and fast, and to improve development productivity. With cowboy_swagger is possible to integrate Swagger to your Erlang projects that use Cowboy as a web server. It is extremely easy to use, and with just a few steps you'll have a nice Web documentation for your RESTful APIs. To learn a bit more about Swagger, please check this blog post .","ref":"readme.html#why-cowboy-swagger","title":"README - Why Cowboy Swagger?","type":"extras"},{"doc":"This is the best part. It is extremely easy. 1. Document each Cowboy Handler Because cowboy_swagger runs on top of trails , the first thing that you have to do is document all about your handler within the trails metadata. Keep in mind that all fields defined within each method into the metadata must be compliant with the Swagger specification . For example, suppose that you have example_echo_handler , so it must implement the trails_handler:trails/0 callback: trails ( ) -&gt; Metadata = \#{ get =&gt; \#{ tags =&gt; [ &quot;echo&quot; ] , description =&gt; &quot;Gets echo var from the server&quot; , produces =&gt; [ &quot;text/plain&quot; ] } , put =&gt; \#{ tags =&gt; [ &quot;echo&quot; ] , description =&gt; &quot;Sets echo var in the server&quot; , produces =&gt; [ &quot;text/plain&quot; ] , parameters =&gt; [ \#{ name =&gt; &lt;&lt; &quot;echo&quot; &gt;&gt; , description =&gt; &lt;&lt; &quot;Echo message&quot; &gt;&gt; , in =&gt; &lt;&lt; &quot;path&quot; &gt;&gt; , required =&gt; false , type =&gt; &lt;&lt; &quot;string&quot; &gt;&gt; } ] } } , [ trails : trail ( &quot;/message/[:echo]&quot; , example_echo_handler , [ ] , Metadata ) ] . To get a better idea of how your handler should look like, please check example/src/example_echo_handler.erl . 2. Include cowboy_swagger in your app First, you need to include cowboy_swagger_handler module in your list of trails to be compiled. % Include cowboy_swagger_handler in the trails list Trails = trails : trails ( [ example_echo_handler , example_description_handler , cowboy_swagger_handler ] ) , % store them trails : store ( Trails ) , % and then compile them Dispatch = trails : single_host_compile ( Trails ) , The snippet of code above is usually placed when you start cowboy . Check it here . Then add cowboy_swagger to the list of apps to be loaded in your *.app.src file. { application , example , [ { description , &quot;Cowboy Swagger Basic Example.&quot; } , { vsn , &quot;0.1&quot; } , { applications , [ kernel , stdlib , jsx , cowboy , trails , cowboy_swagger ] } , { modules , [ ] } , { mod , { example , [ ] } } , { registered , [ ] } , { start_phases , [ { start_trails_http , [ ] } ] } ] } . And that's it, you got it. Now start your application and then you will have access to the API docs under the path /api-docs . Supposing that you're running the app on localhost:8080 , that will be http://localhost:8080/api-docs .","ref":"readme.html#how-to-use-it","title":"README - How to Use it?","type":"extras"},{"doc":"Additionally, cowboy_swagger can be configured/customized from a *.config file: app.config [ %% Other apps ... %% cowboy_swagger config { cowboy_swagger , [ %% `static_files`: Static content directory. This is where Swagger-UI %% is located. Default: `priv/swagger`. %% Remember that Swagger-UI is embedded into `cowboy-swagger` project, %% within `priv/swagger` folder. BUT you have to reference that path, %% and depending on how you&#39;re using `cowboy-swagger` it will be different. %% For example, assuming that you want to run your app which has %% `cowboy-swagger` as dependency from the console, `static_files` will be: { static_files , &quot;./deps/cowboy_swagger/priv/swagger&quot; } , %% `global_spec`: Global fields for Swagger specification. %% If these fields are not set, `cowboy_swagger` will set default values. { global_spec , \#{ swagger =&gt; &quot;2.0&quot; , info =&gt; \#{ title =&gt; &quot;Example API&quot; } , basePath =&gt; &quot;/api-docs&quot; } } ] } ] . Definitions Definitions can be used for describing parameters , responses and security schemas. For adding definitions to your app, you have 2 choices: Add a definitions key to your cowboy_swagger global_spec map. Add them by calling cowboy_swagger:add_definition/2 and send the definition's name and properties. Let's say you want to describe a POST call to a newspapers endpoint that requires name and description fields only, you can do it like this: Option 1: [ . . . % other configurations , { cowboy_swagger , [ { global_spec , \#{ swagger =&gt; &quot;2.0&quot; , info =&gt; \#{ title =&gt; &quot;My app API&quot; } , definitions =&gt; \#{ &quot;RequestBody&quot; =&gt; \#{ &quot;name&quot; =&gt; \#{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;description&quot; =&gt; &quot;Newspaper name&quot; } , &quot;description&quot; =&gt; \#{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;description&quot; =&gt; &quot;Newspaper description&quot; } } } } } ] } ] Option 2: For the second choice, you can do it for example in one or several start_phases , directly in your handler or any other place you want. - spec trails ( ) -&gt; trails : trails ( ) . trails ( ) -&gt; DefinitionName = &lt;&lt; &quot;RequestBody&quot; &gt;&gt; , DefinitionProperties = \#{ &lt;&lt; &quot;name&quot; &gt;&gt; =&gt; \#{ type =&gt; &lt;&lt; &quot;string&quot; &gt;&gt; , description =&gt; &lt;&lt; &quot;Newspaper name&quot; &gt;&gt; } , &lt;&lt; &quot;description&quot; &gt;&gt; =&gt; \#{ type =&gt; &lt;&lt; &quot;string&quot; &gt;&gt; , description =&gt; &lt;&lt; &quot;Newspaper description&quot; &gt;&gt; } } , % Add the definition ok = cowboy_swagger : add_definition ( DefinitionName , DefinitionProperties ) , . . . Now in your handler's trails callback function you can use it: . . . RequestBody = \#{ name =&gt; &lt;&lt; &quot;request body&quot; &gt;&gt; , in =&gt; body , description =&gt; &lt;&lt; &quot;request body (as json)&quot; &gt;&gt; , required =&gt; true % Use the previously created `RequestBody&#39; definition , schema =&gt; cowboy_swagger : schema ( &lt;&lt; &quot;RequestBody&quot; &gt;&gt; ) } , Metadata = \#{ get =&gt; \#{ tags =&gt; [ &quot;newspapers&quot; ] , description =&gt; &quot;Returns the list of newspapers&quot; , produces =&gt; [ &quot;application/json&quot; ] } , post =&gt; # { tags =&gt; [ &quot;newspapers&quot; ] , description =&gt; &quot;Creates a new newspaper&quot; , consumes =&gt; [ &quot;application/json&quot; ] , produces =&gt; [ &quot;application/json&quot; ] , parameters =&gt; [ RequestBody ] % and then use that parameter here } } , Path = &quot;/newspapers&quot; , Options = \#{ path =&gt; Path } , [ trails : trail ( Path , newspapers_handler , Options , Metadata ) ] . What this does for you is add a nice response , parameter or security model in swagger-ui, so client developers will know exactly what parameters the API expects for every endpoint.","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"For more information about cowboy_swagger and how to use it, please check this Example .","ref":"readme.html#example","title":"README - Example","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 https://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;{}&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright {yyyy} {name of copyright owner} Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at https://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]